" VIM Syntax file for txr
" Kaz Kylheku <kaz@kylheku.com>

" INSTALL-HOWTO:
"
" 1. Create the directory .vim/syntax in your home directory and
"    put the files txr.vim and tl.vim into this directory.
" 2. In your .vimrc, add this command to associate *.txr and *.tl
"    files with the txr and tl filetypes:
"    :au BufRead,BufNewFile *.txr set filetype=txr | set lisp
"    :au BufRead,BufNewFile *.tl set filetype=tl | set lisp
"
" If you want syntax highlighting to be on automatically (for any language)
" you need to add ":syntax on" in your .vimrc also. But you knew that already!
"
" This file is generated by the genvim.txr script in the TXR source tree.

syn case match
syn spell toplevel

setlocal iskeyword=a-z,A-Z,48-57,!,$,&,*,+,-,:,<,=,>,?,\\,_,~,/

syn keyword tl_keyword contained %e% %pi% * *args*
syn keyword tl_keyword contained *args-full* *e* *flo-dig* *flo-epsilon*
syn keyword tl_keyword contained *flo-max* *flo-min* *full-args* *gensym-counter*
syn keyword tl_keyword contained *keyword-package* *lib-version* *listener-hist-len* *listener-multi-line-p*
syn keyword tl_keyword contained *listener-sel-inclusive-p* *pi* *place-clobber-expander* *place-delete-expander*
syn keyword tl_keyword contained *place-macro* *place-update-expander* *print-base* *print-flo-digits*
syn keyword tl_keyword contained *print-flo-format* *print-flo-precision* *random-state* *random-warmup*
syn keyword tl_keyword contained *self-path* *stddebug* *stderr* *stdin*
syn keyword tl_keyword contained *stdlog* *stdnull* *stdout* *system-package*
syn keyword tl_keyword contained *txr-version* *unhandled-hook* *user-package* +
syn keyword tl_keyword contained - / /= :
syn keyword tl_keyword contained :addr :append :args :atime
syn keyword tl_keyword contained :auto :blksize :blocks :byte-oriented
syn keyword tl_keyword contained :cdigit :chars :continue :counter
syn keyword tl_keyword contained :cspace :ctime :cword-char :decline
syn keyword tl_keyword contained :dev :digit :downcase :env
syn keyword tl_keyword contained :equal-based :fd :filter :fini
syn keyword tl_keyword contained :finish :form :from-current :from-end
syn keyword tl_keyword contained :from-start :from_html :frombase64 :fromhtml
syn keyword tl_keyword contained :frompercent :fromurl :fun :function
syn keyword tl_keyword contained :gap :gid :greedy :hextoint
syn keyword tl_keyword contained :init :ino :instance :into
syn keyword tl_keyword contained :lfilt :lines :list :longest
syn keyword tl_keyword contained :mandatory :maxgap :maxtimes :method
syn keyword tl_keyword contained :mingap :mintimes :mode :mtime
syn keyword tl_keyword contained :name :named :next-spec :nlink
syn keyword tl_keyword contained :nothrow :postinit :prio :rdev
syn keyword tl_keyword contained :real-time :reflect :repeat-spec :resolve
syn keyword tl_keyword contained :rfilt :shortest :size :space
syn keyword tl_keyword contained :static :string :symacro :times
syn keyword tl_keyword contained :tlist :to_html :tobase64 :tofloat
syn keyword tl_keyword contained :tohtml :tohtml* :toint :tonumber
syn keyword tl_keyword contained :topercent :tourl :uid :upcase
syn keyword tl_keyword contained :var :vars :weak-keys :weak-vals
syn keyword tl_keyword contained :whole :word-char :wrap <
syn keyword tl_keyword contained <= = > >=
syn keyword tl_keyword contained abort abs abs-path-p acons
syn keyword tl_keyword contained acons-new aconsql-new acos ado
syn keyword tl_keyword contained af-inet af-inet6 af-unix af-unspec
syn keyword tl_keyword contained ai-addrconfig ai-all ai-canonname ai-numerichost
syn keyword tl_keyword contained ai-numericserv ai-passive ai-v4mapped alist-nremove
syn keyword tl_keyword contained alist-remove all and andf
syn keyword tl_keyword contained ap apf append append*
syn keyword tl_keyword contained append-each append-each* apply aret
syn keyword tl_keyword contained ash asin assoc assql
syn keyword tl_keyword contained at-exit-call at-exit-do-not-call atan atan2
syn keyword tl_keyword contained atom base64-decode base64-encode bignump
syn keyword tl_keyword contained bindable bit block block*
syn keyword tl_keyword contained boundp break-str brkint bs0
syn keyword tl_keyword contained bs1 bsdly butlast caaaaar
syn keyword tl_keyword contained caaaadr caaaar caaadar caaaddr
syn keyword tl_keyword contained caaadr caaar caadaar caadadr
syn keyword tl_keyword contained caadar caaddar caadddr caaddr
syn keyword tl_keyword contained caadr caar cadaaar cadaadr
syn keyword tl_keyword contained cadaar cadadar cadaddr cadadr
syn keyword tl_keyword contained cadar caddaar caddadr caddar
syn keyword tl_keyword contained cadddar caddddr cadddr caddr
syn keyword tl_keyword contained cadr call call-clobber-expander call-delete-expander
syn keyword tl_keyword contained call-finalizers call-super-fun call-super-method call-update-expander
syn keyword tl_keyword contained callf car caseq caseql
syn keyword tl_keyword contained casequal cat-str cat-streams cat-vec
syn keyword tl_keyword contained catch catenated-stream-p catenated-stream-push cbaud
syn keyword tl_keyword contained cbaudex cdaaaar cdaaadr cdaaar
syn keyword tl_keyword contained cdaadar cdaaddr cdaadr cdaar
syn keyword tl_keyword contained cdadaar cdadadr cdadar cdaddar
syn keyword tl_keyword contained cdadddr cdaddr cdadr cdar
syn keyword tl_keyword contained cddaaar cddaadr cddaar cddadar
syn keyword tl_keyword contained cddaddr cddadr cddar cdddaar
syn keyword tl_keyword contained cdddadr cdddar cddddar cdddddr
syn keyword tl_keyword contained cddddr cdddr cddr cdr
syn keyword tl_keyword contained ceil chain chand chdir
syn keyword tl_keyword contained chmod chr-digit chr-int chr-isalnum
syn keyword tl_keyword contained chr-isalpha chr-isascii chr-isblank chr-iscntrl
syn keyword tl_keyword contained chr-isdigit chr-isgraph chr-islower chr-isprint
syn keyword tl_keyword contained chr-ispunct chr-isspace chr-isunisp chr-isupper
syn keyword tl_keyword contained chr-isxdigit chr-num chr-str chr-str-set
syn keyword tl_keyword contained chr-tolower chr-toupper chr-xdigit chrp
syn keyword tl_keyword contained clamp clear-error clear-struct clocal
syn keyword tl_keyword contained close-stream closelog cmp-str cmspar
syn keyword tl_keyword contained collect-each collect-each* comb compl-span-str
syn keyword tl_keyword contained cond conda condlet cons
syn keyword tl_keyword contained conses conses* consp constantp
syn keyword tl_keyword contained copy copy-alist copy-cons copy-hash
syn keyword tl_keyword contained copy-list copy-str copy-struct copy-vec
syn keyword tl_keyword contained cos count-if countq countql
syn keyword tl_keyword contained countqual cr0 cr1 cr2
syn keyword tl_keyword contained cr3 crdly cread crtscts
syn keyword tl_keyword contained crypt cs5 cs6 cs7
syn keyword tl_keyword contained cs8 csize cstopb cum-norm-dist
syn keyword tl_keyword contained daemon dec defex define-accessor
syn keyword tl_keyword contained define-modify-macro define-place-macro defmacro defmeth
syn keyword tl_keyword contained defparm defparml defplace defstruct
syn keyword tl_keyword contained defsymacro defun defvar defvarl
syn keyword tl_keyword contained del delay delete-package display-width
syn keyword tl_keyword contained do dohash dotimes downcase-str
syn keyword tl_keyword contained drop drop-until drop-while dup
syn keyword tl_keyword contained dupfd dwim each each*
syn keyword tl_keyword contained echo echoctl echoe echok
syn keyword tl_keyword contained echoke echonl echoprt eighth
syn keyword tl_keyword contained empty endgrent endpwent ensure-dir
syn keyword tl_keyword contained env env-fbind env-hash env-vbind
syn keyword tl_keyword contained eq eql equal errno
syn keyword tl_keyword contained error eval evenp exception-subtype-p
syn keyword tl_keyword contained exec exit exit* exp
syn keyword tl_keyword contained expand-left expand-right expt exptmod
syn keyword tl_keyword contained extproc false fboundp ff0
syn keyword tl_keyword contained ff1 ffdly fifth fileno
syn keyword tl_keyword contained filter-equal filter-string-tree finalize find
syn keyword tl_keyword contained find-frame find-if find-max find-min
syn keyword tl_keyword contained find-package find-struct-type first fixnum-max
syn keyword tl_keyword contained fixnum-min fixnump flatcar flatcar*
syn keyword tl_keyword contained flatten flatten* flet flip
syn keyword tl_keyword contained flipargs flo-dig flo-epsilon flo-int
syn keyword tl_keyword contained flo-max flo-max-dig flo-min flo-str
syn keyword tl_keyword contained floatp floor flush-stream flusho
syn keyword tl_keyword contained fmakunbound fmt fnm-casefold fnm-leading-dir
syn keyword tl_keyword contained fnm-noescape fnm-pathname fnm-period fnmatch
syn keyword tl_keyword contained for for* force fork
syn keyword tl_keyword contained format fourth from fstat
syn keyword tl_keyword contained ftw ftw-actionretval ftw-chdir ftw-continue
syn keyword tl_keyword contained ftw-d ftw-depth ftw-dnr ftw-dp
syn keyword tl_keyword contained ftw-f ftw-mount ftw-ns ftw-phys
syn keyword tl_keyword contained ftw-skip-siblings ftw-skip-subtree ftw-sl ftw-sln
syn keyword tl_keyword contained ftw-stop fun func-get-env func-get-form
syn keyword tl_keyword contained func-get-name func-set-env functionp gcd
syn keyword tl_keyword contained gen generate gensym gequal
syn keyword tl_keyword contained get-byte get-char get-clobber-expander get-delete-expander
syn keyword tl_keyword contained get-error get-error-str get-frames get-hash-userdata
syn keyword tl_keyword contained get-indent get-indent-mode get-line get-lines
syn keyword tl_keyword contained get-list-from-stream get-sig-handler get-string get-string-from-stream
syn keyword tl_keyword contained get-update-expander getaddrinfo getegid getenv
syn keyword tl_keyword contained geteuid getgid getgrent getgrgid
syn keyword tl_keyword contained getgrnam getgroups gethash getitimer
syn keyword tl_keyword contained getpid getppid getpwent getpwnam
syn keyword tl_keyword contained getpwuid getresgid getresuid getuid
syn keyword tl_keyword contained ginterate giterate glob glob-altdirfunc
syn keyword tl_keyword contained glob-brace glob-err glob-mark glob-nocheck
syn keyword tl_keyword contained glob-noescape glob-nomagic glob-nosort glob-onlydir
syn keyword tl_keyword contained glob-period glob-tilde glob-tilde-check greater
syn keyword tl_keyword contained group-by group-reduce gun handle
syn keyword tl_keyword contained handler-bind hash hash-alist hash-begin
syn keyword tl_keyword contained hash-construct hash-count hash-diff hash-eql
syn keyword tl_keyword contained hash-equal hash-from-pairs hash-isec hash-keys
syn keyword tl_keyword contained hash-list hash-next hash-pairs hash-proper-subset
syn keyword tl_keyword contained hash-revget hash-subset hash-uni hash-update
syn keyword tl_keyword contained hash-update-1 hash-values hashp have
syn keyword tl_keyword contained html-decode html-encode html-encode* hupcl
syn keyword tl_keyword contained iapply icanon icrnl identity
syn keyword tl_keyword contained ido iexten if ifa
syn keyword tl_keyword contained iff iffi iflet ignbrk
syn keyword tl_keyword contained igncr ignerr ignpar imaxbel
syn keyword tl_keyword contained in in6addr-any in6addr-loopback inaddr-any
syn keyword tl_keyword contained inaddr-loopback inc inc-indent indent-code
syn keyword tl_keyword contained indent-data indent-off inhash inlcr
syn keyword tl_keyword contained inpck int-chr int-flo int-str
syn keyword tl_keyword contained integerp intern interp-fun-p interpose
syn keyword tl_keyword contained invoke-catch ip ipf iread
syn keyword tl_keyword contained isig isqrt istrip itimer-prov
syn keyword tl_keyword contained itimer-real itimer-virtual iuclc iutf8
syn keyword tl_keyword contained ixany ixoff ixon juxt
syn keyword tl_keyword contained keep-if keep-if* keyword-package keywordp
syn keyword tl_keyword contained kill labels lambda last
syn keyword tl_keyword contained lazy-str lazy-str-force lazy-str-force-upto lazy-str-get-trailing-list
syn keyword tl_keyword contained lazy-stream-cons lazy-stringp lcm lcons
syn keyword tl_keyword contained lcons-fun lconsp ldiff length
syn keyword tl_keyword contained length-list length-str length-str-< length-str-<=
syn keyword tl_keyword contained length-str-> length-str->= length-vec lequal
syn keyword tl_keyword contained less let let* lexical-fun-p
syn keyword tl_keyword contained lexical-lisp1-binding lexical-var-p lib-version link
syn keyword tl_keyword contained lisp-parse list list* list-str
syn keyword tl_keyword contained list-vec list-vector listp lnew
syn keyword tl_keyword contained load log log-alert log-auth
syn keyword tl_keyword contained log-authpriv log-cons log-crit log-daemon
syn keyword tl_keyword contained log-debug log-emerg log-err log-info
syn keyword tl_keyword contained log-ndelay log-notice log-nowait log-odelay
syn keyword tl_keyword contained log-perror log-pid log-user log-warning
syn keyword tl_keyword contained log10 log2 logand logior
syn keyword tl_keyword contained lognot logtest logtrunc logxor
syn keyword tl_keyword contained lset lstat mac-param-bind macro-ancestor
syn keyword tl_keyword contained macro-form-p macro-time macroexpand macroexpand-1
syn keyword tl_keyword contained macrolet major make-catenated-stream make-env
syn keyword tl_keyword contained make-hash make-lazy-cons make-lazy-struct make-like
syn keyword tl_keyword contained make-package make-random-state make-similar-hash make-string-byte-input-stream
syn keyword tl_keyword contained make-string-input-stream make-string-output-stream make-strlist-output-stream make-struct
syn keyword tl_keyword contained make-struct-type make-sym make-time make-time-utc
syn keyword tl_keyword contained make-trie makedev makunbound mapcar
syn keyword tl_keyword contained mapcar* mapdo mapf maphash
syn keyword tl_keyword contained mappend mappend* mask match-fun
syn keyword tl_keyword contained match-regex match-regex-right match-regst match-regst-right
syn keyword tl_keyword contained match-str match-str-tree max mboundp
syn keyword tl_keyword contained member member-if memq memql
syn keyword tl_keyword contained memqual merge meth method
syn keyword tl_keyword contained min minor minusp mkdir
syn keyword tl_keyword contained mknod mkstring mlet mmakunbound
syn keyword tl_keyword contained mod multi multi-sort n-choose-k
syn keyword tl_keyword contained n-perm-k nconc new nexpand-left
syn keyword tl_keyword contained nil nilf ninth nl0
syn keyword tl_keyword contained nl1 nldly noflsh none
syn keyword tl_keyword contained not notf nreconc nreverse
syn keyword tl_keyword contained nthcdr null nullify num-chr
syn keyword tl_keyword contained num-str numberp oand obtain
syn keyword tl_keyword contained obtain* obtain*-block obtain-block ocrnl
syn keyword tl_keyword contained oddp ofdel ofill olcuc
syn keyword tl_keyword contained onlcr onlret onocr op
syn keyword tl_keyword contained open-command open-directory open-file open-fileno
syn keyword tl_keyword contained open-files open-files* open-pipe open-process
syn keyword tl_keyword contained open-socket open-socket-pair open-tail openlog
syn keyword tl_keyword contained opip opost or orf
syn keyword tl_keyword contained package-alist package-name package-symbols packagep
syn keyword tl_keyword contained pad parenb parmrk parodd
syn keyword tl_keyword contained partition partition* partition-by path-blkdev-p
syn keyword tl_keyword contained path-chrdev-p path-dir-p path-executable-to-me-p path-exists-p
syn keyword tl_keyword contained path-file-p path-mine-p path-my-group-p path-newer
syn keyword tl_keyword contained path-older path-pipe-p path-private-to-me-p path-read-writable-to-me-p
syn keyword tl_keyword contained path-readable-to-me-p path-same-object path-setgid-p path-setuid-p
syn keyword tl_keyword contained path-sock-p path-sticky-p path-strictly-private-to-me-p path-symlink-p
syn keyword tl_keyword contained path-writable-to-me-p pendin perm pipe
syn keyword tl_keyword contained place-form-p placelet placelet* plusp
syn keyword tl_keyword contained poll poll-err poll-in poll-nval
syn keyword tl_keyword contained poll-out poll-pri poll-rdband poll-rdhup
syn keyword tl_keyword contained poll-wrband pop pos pos-if
syn keyword tl_keyword contained pos-max pos-min posq posql
syn keyword tl_keyword contained posqual pppred ppred pprinl
syn keyword tl_keyword contained pprint pprof pred prinl
syn keyword tl_keyword contained print prof prog1 progn
syn keyword tl_keyword contained promisep prop proper-list-p proper-listp
syn keyword tl_keyword contained pset push pushhash pushnew
syn keyword tl_keyword contained put-byte put-char put-line put-lines
syn keyword tl_keyword contained put-string put-strings pwd qquote
syn keyword tl_keyword contained qref quote raise rand
syn keyword tl_keyword contained random random-fixnum random-state-get-vec random-state-p
syn keyword tl_keyword contained range range* range-regex rangep
syn keyword tl_keyword contained rcomb rcons read read-until-match
syn keyword tl_keyword contained readlink real-time-stream-p record-adapter reduce-left
syn keyword tl_keyword contained reduce-right ref refset regex-compile
syn keyword tl_keyword contained regex-parse regexp register-exception-subtypes regsub
syn keyword tl_keyword contained rehome-sym remhash remove-if remove-if*
syn keyword tl_keyword contained remove-path remq remq* remql
syn keyword tl_keyword contained remql* remqual remqual* rename-path
syn keyword tl_keyword contained repeat replace replace-list replace-str
syn keyword tl_keyword contained replace-struct replace-vec reset-struct rest
syn keyword tl_keyword contained ret retf return return*
syn keyword tl_keyword contained return-from revappend reverse rfind
syn keyword tl_keyword contained rfind-if rlcp rlet rmember
syn keyword tl_keyword contained rmember-if rmemq rmemql rmemqual
syn keyword tl_keyword contained rotate rperm rplaca rplacd
syn keyword tl_keyword contained rpos rpos-if rposq rposql
syn keyword tl_keyword contained rposqual rsearch run s-ifblk
syn keyword tl_keyword contained s-ifchr s-ifdir s-ififo s-iflnk
syn keyword tl_keyword contained s-ifmt s-ifreg s-ifsock s-irgrp
syn keyword tl_keyword contained s-iroth s-irusr s-irwxg s-irwxo
syn keyword tl_keyword contained s-irwxu s-isgid s-isuid s-isvtx
syn keyword tl_keyword contained s-iwgrp s-iwoth s-iwusr s-ixgrp
syn keyword tl_keyword contained s-ixoth s-ixusr search search-regex
syn keyword tl_keyword contained search-regst search-str search-str-tree second
syn keyword tl_keyword contained seek-stream select self-load-path self-path
syn keyword tl_keyword contained seqp set set-diff set-hash-userdata
syn keyword tl_keyword contained set-indent set-indent-mode set-sig-handler setegid
syn keyword tl_keyword contained setenv seteuid setgid setgrent
syn keyword tl_keyword contained setgroups sethash setitimer setlogmask
syn keyword tl_keyword contained setpwent setresgid setresuid setuid
syn keyword tl_keyword contained seventh sh shift shuffle
syn keyword tl_keyword contained shut-rd shut-rdwr shut-wr sig-abrt
syn keyword tl_keyword contained sig-alrm sig-bus sig-check sig-chld
syn keyword tl_keyword contained sig-cont sig-fpe sig-hup sig-ill
syn keyword tl_keyword contained sig-int sig-io sig-iot sig-kill
syn keyword tl_keyword contained sig-pipe sig-poll sig-prof sig-pwr
syn keyword tl_keyword contained sig-quit sig-segv sig-stkflt sig-stop
syn keyword tl_keyword contained sig-sys sig-term sig-trap sig-tstp
syn keyword tl_keyword contained sig-ttin sig-ttou sig-urg sig-usr1
syn keyword tl_keyword contained sig-usr2 sig-vtalrm sig-winch sig-xcpu
syn keyword tl_keyword contained sig-xfsz sign-extend sin sixth
syn keyword tl_keyword contained size-vec slot slotp slotset
syn keyword tl_keyword contained sock-accept sock-bind sock-cloexec sock-connect
syn keyword tl_keyword contained sock-dgram sock-family sock-listen sock-nonblock
syn keyword tl_keyword contained sock-peer sock-recv-timeout sock-send-timeout sock-set-peer
syn keyword tl_keyword contained sock-shutdown sock-stream sock-type some
syn keyword tl_keyword contained sort sort-group source-loc source-loc-str
syn keyword tl_keyword contained span-str special-operator-p special-var-p splice
syn keyword tl_keyword contained split split* split-str split-str-set
syn keyword tl_keyword contained sqrt sssucc ssucc stat
syn keyword tl_keyword contained static-slot static-slot-ensure static-slot-p static-slot-set
syn keyword tl_keyword contained stdlib str-in6addr str-in6addr-net str-inaddr
syn keyword tl_keyword contained str-inaddr-net str< str<= str=
syn keyword tl_keyword contained str> str>= stream-get-prop stream-set-prop
syn keyword tl_keyword contained streamp string-extend string-lt stringp
syn keyword tl_keyword contained struct-type struct-type-p structp sub
syn keyword tl_keyword contained sub-list sub-str sub-vec subtypep
syn keyword tl_keyword contained succ super super-method suspend
syn keyword tl_keyword contained swap symacrolet symbol-function symbol-macro
syn keyword tl_keyword contained symbol-name symbol-package symbol-value symbolp
syn keyword tl_keyword contained symlink sys:*lisp1* sys:abscond* sys:abscond-from
syn keyword tl_keyword contained sys:apply sys:bad-slot-syntax sys:capture-cont sys:cp-origin
syn keyword tl_keyword contained sys:defmeth sys:do-path-test sys:dwim-del sys:dwim-set
syn keyword tl_keyword contained sys:eval-err sys:expand sys:expr sys:fbind
syn keyword tl_keyword contained sys:gc sys:gc-set-delta sys:get-fb sys:get-mb
syn keyword tl_keyword contained sys:get-vb sys:handle-bad-syntax sys:if-to-cond sys:in6addr-condensed-text
syn keyword tl_keyword contained sys:l1-setq sys:l1-val sys:lbind sys:lisp1-setq
syn keyword tl_keyword contained sys:lisp1-value sys:load sys:make-struct-type sys:mark-special
syn keyword tl_keyword contained sys:obtain-impl sys:path-access sys:path-examine sys:path-test
syn keyword tl_keyword contained sys:path-test-mode sys:pl-expand sys:placelet-1 sys:prune-nil-inits
syn keyword tl_keyword contained sys:qquote sys:quasi sys:quasilist sys:reg-expand-nongreedy
syn keyword tl_keyword contained sys:reg-optimize sys:register-simple-accessor sys:rplaca sys:rplacd
syn keyword tl_keyword contained sys:set-hash-rec-limit sys:set-hash-str-limit sys:set-macro-ancestor sys:setq
syn keyword tl_keyword contained sys:setqf sys:splice sys:str-inaddr-net-impl sys:struct-lit
syn keyword tl_keyword contained sys:sym-clobber-expander sys:sym-delete-expander sys:sym-update-expander sys:top-fb
syn keyword tl_keyword contained sys:top-mb sys:top-vb sys:unquote sys:var
syn keyword tl_keyword contained sys:with-saved-vars syslog system-package t
syn keyword tl_keyword contained tab0 tab1 tab2 tab3
syn keyword tl_keyword contained tabdly take take-until take-while
syn keyword tl_keyword contained tan tb tc tcdrain
syn keyword tl_keyword contained tcflow tcflush tcgetattr tciflush
syn keyword tl_keyword contained tcioff tcioflush tcion tcoflush
syn keyword tl_keyword contained tcooff tcoon tcsadrain tcsaflush
syn keyword tl_keyword contained tcsanow tcsendbreak tcsetattr tenth
syn keyword tl_keyword contained test-set-indent-mode tf third throw
syn keyword tl_keyword contained throwf time time-fields-local time-fields-utc
syn keyword tl_keyword contained time-string-local time-string-utc time-struct-local time-struct-utc
syn keyword tl_keyword contained time-usec to tofloat toint
syn keyword tl_keyword contained tok-str tok-where tostop tostring
syn keyword tl_keyword contained tostringp tprint transpose tree-bind
syn keyword tl_keyword contained tree-case tree-find trie-add trie-compress
syn keyword tl_keyword contained trie-lookup-begin trie-lookup-feed-char trie-value-at trim-str
syn keyword tl_keyword contained true trunc trunc-rem truncate-stream
syn keyword tl_keyword contained tuples txr-case txr-case-impl txr-if
syn keyword tl_keyword contained txr-path txr-sym txr-version txr-when
syn keyword tl_keyword contained typecase typeof typep umask
syn keyword tl_keyword contained umeth umethod unget-byte unget-char
syn keyword tl_keyword contained uniq unique unless unquote
syn keyword tl_keyword contained unsetenv until until* unwind-protect
syn keyword tl_keyword contained upcase-str update url-decode url-encode
syn keyword tl_keyword contained use user-package usl usleep
syn keyword tl_keyword contained uslot vdiscard vec vec-list
syn keyword tl_keyword contained vec-push vec-set-length vecref vector
syn keyword tl_keyword contained vector-list vectorp veof veol
syn keyword tl_keyword contained veol2 verase vintr vkill
syn keyword tl_keyword contained vlnext vmin vquit vreprint
syn keyword tl_keyword contained vstart vstop vsusp vswtc
syn keyword tl_keyword contained vt0 vt1 vtdly vtime
syn keyword tl_keyword contained vwerase w-continued w-coredump w-exitstatus
syn keyword tl_keyword contained w-ifcontinued w-ifexited w-ifsignaled w-ifstopped
syn keyword tl_keyword contained w-nohang w-stopsig w-termsig w-untraced
syn keyword tl_keyword contained wait weave when whenlet
syn keyword tl_keyword contained where while while* whilet
syn keyword tl_keyword contained width width-check window-map window-mappend
syn keyword tl_keyword contained with-clobber-expander with-delete-expander with-gensyms with-hash-iter
syn keyword tl_keyword contained with-in-string-byte-stream with-in-string-stream with-objects with-out-string-stream
syn keyword tl_keyword contained with-out-strlist-stream with-resources with-slots with-stream
syn keyword tl_keyword contained with-update-expander wrap wrap* xcase
syn keyword tl_keyword contained yield yield-from zap zerop
syn keyword tl_keyword contained zip

syn keyword txr_keyword contained accept all and assert
syn keyword txr_keyword contained bind block call cases
syn keyword txr_keyword contained cat catch choose chr
syn keyword txr_keyword contained close coll collect data
syn keyword txr_keyword contained defex deffilter define do
syn keyword txr_keyword contained elif else empty end
syn keyword txr_keyword contained eof eol fail filter
syn keyword txr_keyword contained finally first flatten forget
syn keyword txr_keyword contained freeform fuzz gather if
syn keyword txr_keyword contained include last line load
syn keyword txr_keyword contained local maybe merge mod
syn keyword txr_keyword contained modlast name next none
syn keyword txr_keyword contained or output rebind rep
syn keyword txr_keyword contained repeat require set single
syn keyword txr_keyword contained skip some text throw
syn keyword txr_keyword contained trailer try until var
syn match txr_error "\(@[ \t]*\)[*]\?[\t ]*."
syn match txr_atat "\(@[ \t]*\)@"
syn match txr_comment "\(@[ \t]*\)[#;].*"
syn match txr_contin "\(@[ \t]*\)\\$"
syn match txr_char "\(@[ \t]*\)\\."
syn match txr_error "\(@[ \t]*\)\\[xo]"
syn match txr_char "\(@[ \t]*\)\\x[0-9A-Fa-f]\+;\?"
syn match txr_char "\(@[ \t]*\)\\[0-7]\+;\?"
syn match txr_regdir "\(@[ \t]*\)/\(\\/\|[^/]\|\\\n\)*/"
syn match txr_hashbang "^#!.*"
syn match txr_nested_error "[^\t ]\+" contained
syn match txr_variable "\(@[ \t]*\)[*]\?[ \t]*[A-Za-z_][A-Za-z_0-9]*"
syn match txr_splicevar "@[ \t,*@]*[A-Za-z_][A-Za-z_0-9]*" contained
syn match txr_metanum "@\+[0-9]\+" contained
syn match txr_badesc "\\." contained
syn match txr_escat "\\@" contained
syn match txr_stresc "\\[abtnvfre\\ \n"`']" contained
syn match txr_numesc "\\x[0-9A-Fa-f]\+;\?" contained
syn match txr_numesc "\\[0-7]\+;\?" contained
syn match txr_regesc "\\[abtnvfre\\ \n/sSdDwW()\|.*?+~&%\[\]\-]" contained

syn match txr_chr "#\\x[0-9A-Fa-f]\+" contained
syn match txr_chr "#\\o[0-7]\+" contained
syn match txr_chr "#\\[^ \t\nA-Za-z_0-9]" contained
syn match txr_chr "#\\[A-Za-z_0-9]\+" contained
syn match txr_ncomment ";.*" contained

syn match txr_dot "\." contained
syn match txr_num "#x[+\-]\?[0-9A-Fa-f]\+" contained
syn match txr_num "#o[+\-]\?[0-7]\+" contained
syn match txr_num "#b[+\-]\?[01]\+" contained
syn match txr_ident "[A-Za-z_0-9!$%&*+\-<=>?\\_~]*[A-Za-z_!$%&*+\-<=>?\\_~^][A-Za-z_0-9!$%&*+\-<=>?\\_~^]*" contained
syn match tl_ident "[:@][A-Za-z_0-9!$%&*+\-<=>?\\_~^/]\+" contained
syn match txr_braced_ident "[:][A-Za-z_0-9!$%&*+\-<=>?\\_~^/]\+" contained
syn match tl_ident "[A-Za-z_0-9!$%&*+\-<=>?\\_~/]*[A-Za-z_!$%&*+\-<=>?\\_~^/#][A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]*" contained
syn match txr_num "[+\-]\?[0-9]\+\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1 contained
syn match txr_badnum "[+\-]\?[0-9]*[.][0-9]\+\([eE][+\-]\?[0-9]\+\)\?[A-Za-z_!$%&*+\-<=>?\\_~^/#]\+" contained
syn match txr_num "[+\-]\?[0-9]*[.][0-9]\+\([eE][+\-]\?[0-9]\+\)\?\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1 contained
syn match txr_num "[+\-]\?[0-9]\+\([eE][+\-]\?[0-9]\+\)\([^A-Za-z_0-9!$%&*+\-<=>?\\_~^/#]\|\n\)"me=e-1 contained
syn match tl_ident ":" contained
syn match tl_splice "[ \t,]\|,[*]" contained

syn match txr_unquote "," contained
syn match txr_splice ",\*" contained
syn match txr_quote "'" contained
syn match txr_quote "\^" contained
syn match txr_dotdot "\.\." contained
syn match txr_metaat "@" contained

syn region txr_bracevar matchgroup=Delimiter start="@[ \t]*[*]\?{" matchgroup=Delimiter end="}" contains=txr_num,tl_ident,tl_splice,tl_metanum,txr_metaat,txr_braced_ident,txr_dot,txr_dotdot,txr_string,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_regex,txr_quasilit,txr_chr,tl_splice,txr_nested_error
syn region txr_directive matchgroup=Delimiter start="@[ \t]*(" matchgroup=Delimiter end=")" contains=txr_keyword,txr_string,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_num,txr_badnum,tl_ident,tl_regex,txr_string,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_list contained matchgroup=Delimiter start="#\?H\?(" matchgroup=Delimiter end=")" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_badnum,tl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_bracket contained matchgroup=Delimiter start="\[" matchgroup=Delimiter end="\]" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_badnum,tl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_mlist contained matchgroup=Delimiter start="@[ \t^',]*(" matchgroup=Delimiter end=")" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_badnum,tl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_mbracket matchgroup=Delimiter start="@[ \t^',]*\[" matchgroup=Delimiter end="\]" contains=tl_keyword,txr_string,tl_regex,txr_num,txr_badnum,tl_ident,txr_metanum,txr_list,txr_bracket,txr_mlist,txr_mbracket,txr_quasilit,txr_chr,txr_quote,txr_unquote,txr_splice,txr_dot,txr_dotdot,txr_metaat,txr_ncomment,txr_nested_error
syn region txr_string contained start=+#\?\*\?"+ end=+["\n]+ contains=txr_stresc,txr_numesc,txr_badesc
syn region txr_quasilit contained start=+#\?\*\?`+ end=+[`\n]+ contains=txr_splicevar,txr_metanum,txr_bracevar,txr_mlist,txr_mbracket,txr_escat,txr_stresc,txr_numesc,txr_badesc
syn region txr_regex contained start="/" end="[/\n]" contains=txr_regesc,txr_numesc,txr_badesc
syn region tl_regex contained start="#/" end="[/\n]" contains=txr_regesc,txr_numesc,txr_badesc

hi def link txr_at Special
hi def link txr_atstar Special
hi def link txr_atat Special
hi def link txr_comment Comment
hi def link txr_ncomment Comment
hi def link txr_hashbang Preproc
hi def link txr_contin Preproc
hi def link txr_char String
hi def link txr_keyword Keyword
hi def link tl_keyword Type
hi def link txr_string String
hi def link txr_chr String
hi def link txr_quasilit String
hi def link txr_regex String
hi def link tl_regex String
hi def link txr_regdir String
hi def link txr_variable Identifier
hi def link txr_splicevar Identifier
hi def link txr_metanum Identifier
hi def link txr_escat Special
hi def link txr_stresc Special
hi def link txr_numesc Special
hi def link txr_regesc Special
hi def link txr_badesc Error
hi def link txr_ident Identifier
hi def link tl_ident Identifier
hi def link txr_num Number
hi def link txr_badnum Error
hi def link txr_quote Special
hi def link txr_unquote Special
hi def link txr_splice Special
hi def link txr_dot Special
hi def link txr_dotdot Special
hi def link txr_metaat Special
hi def link txr_munqspl Special
hi def link tl_splice Special
hi def link txr_error Error
hi def link txr_nested_error Error

let b:current_syntax = "lisp"

set lispwords=ado,ap,append-each,append-each*,aret,block,block*,caseq,caseql,casequal,catch,collect-each,collect-each*,cond,conda,condlet,dec,defex,define-accessor,define-modify-macro,define-place-macro,defmacro,defmeth,defparm,defparml,defplace,defstruct,defsymacro,defun,defvar,defvarl,del,delay,do,dohash,dotimes,each,each*,flet,flip,for,for*,fun,gen,gun,handle,handler-bind,ido,if,ifa,iflet,ignerr,ip,labels,lambda,lcons,let,let*,load,lset,mac-param-bind,macro-time,macrolet,mlet,obtain,obtain*,obtain*-block,obtain-block,op,placelet,placelet*,pop,pprof,prof,prog1,progn,push,pushnew,ret,return,return-from,rlet,splice,suspend,symacrolet,sys:abscond-from,sys:expr,sys:fbind,sys:l1-val,sys:lbind,sys:lisp1-value,sys:path-examine,sys:path-test,sys:placelet-1,sys:splice,sys:struct-lit,sys:unquote,sys:var,sys:with-saved-vars,tb,tc,tree-bind,tree-case,txr-case,txr-case-impl,txr-if,txr-when,typecase,unless,unquote,until,until*,unwind-protect,when,whenlet,while,while*,whilet,with-clobber-expander,with-delete-expander,with-gensyms,with-hash-iter,with-in-string-byte-stream,with-in-string-stream,with-objects,with-out-string-stream,with-out-strlist-stream,with-resources,with-slots,with-stream,with-update-expander,yield,yield-from,zap,:method,:function,:init,:postinit,:fini
